@echo off



::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::  This file can be used for UnUnRegistering all the dlls of CC/CQ 7.1.1 against VS2010.
::
::  UnRegistration of Dlls has been divided into 4 sections below
::
::  1.Common Components 2.Clearcase Components 3.Clearquest Components 4.CCRC Components
::
::  This is the Initialisation section. The variables are set to the default values.
::
::  Please set the below 8 variables.
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 

:: 1.  Set this value to 1 if you have installed ClearCase 7.1.1 and Visual Studio 2010, else set it to 0
set CC_for_VS=1

:: 2.  Set this value to 1 if you have installed ClearQuest 7.1.1 and Visual Studio 2010, else set it to 0
set CQ_for_VS=0

:: 3.  Set this value to 1 if you have installed ClearCase Remote Client 7.1.1 and Visual Studio 2010, else set it to 0
set CCRC_for_VS=1


:: 4.  Set this value only if you have set CQ_for_VS to 1
:: Set the below variable to the path where you find the following dlls:
:: ActivityGridContainer.dll, ActivityWkspcContainer.dll,ActivityPage.dll, CQPackage.dll.
:: Note:  The defaut location is C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin 
:: You can easily search for your installed location by using Windows Explorer search utility 
:: and giving just one of the names of the dlls from the above list.
:: Once you find that location, just replace it over here within double quotes.

set cqCommon=""



:: 5.  Set this value only if you have set CC_for_VS to 1
:: Set the below variable to the path where you find ccvsilanservice.dll.
:: The defaut location is C:\Program Files\Rational\ClearCase\bin
:: You can easily search for your installed location by using Windows Explorer search utility 
:: and searching for ccvsilanservice.dll.
:: Once you find that location, just replace it over here within double quotes.

set ccLAN="C:\Program Files\IBM\RationalSDLC\ClearCase\bin"



:: 6.  Set this value only if you have set CCRC_for_VS to 1
:: Set the below variable to the path where you find ccvsiwanservice.dll. 
:: Note:  The defaut location is C:\Program Files\IBM\Rational\CCRCVSI\WanPackage
:: You can easily search for your installed location by using Windows Explorer search utility 
:: and searching for ccvsiwanservice.dll.
:: Once you find that location, just replace it over here within double quotes.

set ccWAN="C:\Program Files\IBM\RationalSDLC\ClearCase\RemoteClient\WanPackage"


:: 7.  Ignore this variable if you have set "both" CC_for_VS and CCRC_for_VS to 0.
:: Otherwise, set the below variable to the path where you find one of the following dlls:
:: ccvsiinterfaces.dll, ccvsisearchdefs.dll, Banner.dll, HelpPage.dll,
:: HomePage.dll,PageSelector.dll, ToolsPage.dll, ViewsPage.dll, CTPackage.dll
:: Note:  The defaut location is C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin 
:: You can easily search for your installed location by using Windows Explorer search utility 
:: and giving just one of the names of the dlls from the above list.
:: Once you find that location, just replace it over here within double quotes.

set ccCommon="C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin"



:: 8.  Set the below variable to the path where Visual Studio 2010 devenv.exe is present.
:: Note: The defaut location is C:\Program Files\Microsoft Visual Studio 10.0\Common7\IDE\devenv.exe
:: You can easily search for your installed location by using Windows Explorer search utility 
:: and searching for devenv.exe.
:: Once you find that location, just replace it over here within double quotes.

set VS2010="C:\Program Files\Microsoft Visual Studio 10.0\Common7\IDE\devenv.exe"

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::




























::::::::::::::::::
::begin processing
::::::::::::::::::



set currdir=.
pushd %currdir%
set envsdk_regkey=10.0
set processed=0


:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::UnRegister Common Component dlls


:: if both CC and CCRC for Visual Studio are not installed, then go to label2
if %CC_for_VS% NEQ 1 if %CCRC_for_VS% NEQ 1 goto label2

if not exist %ccCommon%  goto err1

pushd %ccCommon%

set err_str="ccvsiinterfaces.dll"
if not exist ccvsiinterfaces.dll goto err_common

set err_str="ccvsisearchdefs.dll"
if not exist ccvsisearchdefs.dll goto err_common

set err_str="Banner.dll"
if not exist Banner.dll goto err_common

set err_str="HelpPage.dll"
if not exist HelpPage.dll goto err_common

set err_str="HomePage.dll"
if not exist HomePage.dll goto err_common

set err_str="PageSelector.dll"
if not exist PageSelector.dll goto err_common

set err_str="ToolsPage.dll"
if not exist ToolsPage.dll goto err_common

set err_str="ViewsPage.dll"
if not exist ViewsPage.dll goto err_common

set err_str="CTPackage.dll"
if not exist CTPackage.dll goto err_common


echo UnUnRegistering Common components..
regsvr32 /u ccvsiinterfaces.dll
regsvr32 /u ccvsisearchdefs.dll
regsvr32 /u Banner.dll
regsvr32 /u HelpPage.dll
regsvr32 /u HomePage.dll
regsvr32 /u PageSelector.dll
regsvr32 /u ToolsPage.dll
regsvr32 /u ViewsPage.dll
regsvr32 /u CTPackage.dll

popd
if not exist unreg_ccvsisearchtoolwin_VS2010.reg goto err_reg1
 
unreg_ccvsisearchtoolwin_VS2010.reg
pushd %currdir%

set processed=1
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::






:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::UnRegister ClearCase component dlls


:label1

if %CC_for_VS% NEQ 1 goto label2

if not exist %ccLAN% goto err2

pushd %ccLAN%
if not exist ccvsilanservice.dll goto err_cc


echo UnUnRegistering ClearCase components..
regsvr32 /u ccvsilanservice.dll

set processed=1
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::






:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::UnRegister ClearQuest integration dlls with VS2010

:label2

if %CQ_for_VS% NEQ 1 goto label3

if not exist %cqCommon%  goto err3

pushd %cqCommon%

set err_str="ActivityGridContainer.dll"
if not exist ActivityGridContainer.dll goto err_cq

set err_str="ActivityWkspcContainer.dll"
if not exist ActivityWkspcContainer.dll goto err_cq

set err_str="ActivityPage.dll"
if not exist ActivityPage.dll goto err_cq

set err_str="CQPackage.dll"
if not exist CQPackage.dll goto err_cq


echo UnUnRegistering ClearQuest components..
regsvr32 /u ActivityGridContainer.dll
regsvr32 /u ActivityWkspcContainer.dll
regsvr32 /u ActivityPage.dll
regsvr32 /u CQPackage.dll

set processed=1
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::








:::::::::::::::::::::::::::::::::::::::::
::UnRegister CCRC components

:label3

if %CCRC_for_VS% NEQ 1 goto label4

if not exist %ccWAN% goto err4

echo UnUnRegistering CCRC components..
popd
if not exist unreg_ccvsiwanservice_VS2010.reg goto err_reg2

unreg_ccvsiwanservice_VS2010.reg
pushd %currdir%

set processed=1
:::::::::::::::::::::::::::::::::::::::::








::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::Setup VS2010

:label4
if %processed% NEQ 1 goto no_action

if not exist %vs2010% goto err5

echo Doing the setup of VS2010. This will take a few minutes..
%VS2010% /setup
goto end
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


:err_common
echo.
echo %err_str% does not exist.
echo Either there is problem with your ClearCase installation or 
echo make sure that you have set ccCommon variable properly in the batch file.
echo The default location for common components is 
echo C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin
goto end


:err_cc
echo.
echo ccvsilanservice.dll does not exist.
echo 1. You might not have installed Visual Studio integration 
echo    while installing ClearCase.
echo 2. You might have specified ccLAN= %ccLAN% incorrectly. 
echo    Search for ccvsilanservice.dll in Windows search utility 
echo    and specify that path for ccLAN variable.
goto end

:err_cq
echo.
echo %err_str% does not exist.
echo 1. You might not have installed Visual Studio integration 
echo    while installing ClearQuest.
echo 2. You might have specified cqCommon= %cqCommon% incorrectly. 
echo    Search for %err_str% in Windows search utility and 
echo    specify that path for cqCommon variable.
goto end


:err_reg1
echo.
echo Make sure that unreg_ccvsisearchtoolwin_VS2010.reg 
echo is present in the path from where you are 
echo running the batch file
goto end


:err_reg2
echo.
echo Make sure that unreg_ccvsiwanservice_VS2010.reg 
echo is present in the path from where you are 
echo running the batch file
goto end

:err1
echo.
echo ccCommon = %ccCommon% does not exist
echo 1. Check if you have installed IBM ClearCase for Visual Studio.
echo 2. Check if you specified the path properly. The default location is 
echo    C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin
echo. 
echo Search for one of these dlls 
echo ccvsiinterfaces.dll, ccvsisearchdefs.dll, Banner.dll, 
echo HelpPage.dll, HomePage.dll,PageSelector.dll, ToolsPage.dll, 
echo ViewsPage.dll, CTPackage.dll and specify this path in the ccCommon variable.
goto end


:err2
echo.
echo ccLAN = %ccLAN% does not exist
echo 1. Check if you have installed IBM ClearCase for Visual Studio.
echo 2. Check if you specified the path properly. The default location is 
echo    C:\Program Files\Rational\ClearCase\bin
echo.
echo Search for ccvsilanservice.dll
echo and specify that path in ccLAN variable.
goto end


:err3
echo.
echo cqCommon = %cqCommon% does not exist
echo 1. Check if you have installed IBM ClearQuest for Visual Studio.
echo 2. Check if you specified the path properly. The default location is 
echo    C:\Program Files\Common Files\Rational\ClearCase\CCVSI\bin
echo. 
echo Search for one of these dlls 
echo ActivityGridContainer.dll, ActivityWkspcContainer.dll, 
echo ActivityPage.dll, CQPackage.dll and specify that path in the
echo cqCommon variable. 
goto end


:err4
echo.
echo ccWAN = %ccWAN% does not exist
echo 1. Check if you have installed IBM ClearCase Remote Client for Visual Studio.
echo 2. Check if you specified the path properly. The default location is
echo    C:\Program Files\IBM\Rational\CCRCVSI\WanPackage
echo    Search for ccvsiwanservice.dll and specify that path in ccWAN variable.
goto end


:err5
echo.
echo VS2010 = %VS2010% does not exist. 
echo 1. Make sure that Visual Studio 2010 is installed. 
echo 2. Search for devenv.exe and set that path in the VS2010 variable.
goto end


:no_action
echo.
echo No registration done with Visual Studio 2010, since you have not specified 1 in the 
echo batch variables for CC_for_VS, CQ_for_VS, CCRC_for_VS
echo To UnRegister Visual Studio 2010 with either ClearCase or ClearQuest, 
echo specify 1 in the corresponding variable after you are done with the installation.


:end
ECHO.
popd
pause